include "ZeroPage.inc"
include "VVram.inc"

pSource equ ZW0
pDestination equ ZW1
count equ ZB0

dseg
VVramBack_: public VVramBack_
    defs VVramWidth*(VVramHeight+1)
VVramFront_: public VVramFront_
    defs VVramWidth*(VVramHeight+1)
RowFlags_: public RowFlags_
    defs 4+1


; void ClearVVram();
cseg
ClearVVram_: public ClearVVram_
    pha
        lda #low VVramBack_ | sta <pDestination
        lda #high VVramBack_ | sta <pDestination+1
        ldx #VVramHeight
        do
            ldy #0 | tya
            do
                sta (<pDestination),y
                iny
                cpy #VVramWidth
            while ne | wend
            lda <pDestination | clc | adc #low VVramWidth | sta <pDestination
            lda <pDestination+1 | adc #high VVramWidth | sta <pDestination+1
            dex
        while ne | wend
    pla
rts


; ptr<byte> VVramOffset(byte x, byte y);
dseg
VVramOffset_@Param0: public	VVramOffset_@Param0
VVramOffset_.x_:	defs 1
VVramOffset_@Param1: public	VVramOffset_@Param1
VVramOffset_.y_:	defs 1
cseg
VVramOffset_: public	VVramOffset_
	pha
        lda	VVramOffset_.y_
        asl a | asl a | asl a  ;*8
        sta <pDestination | lda #0 | sta <pDestination+1
        asl <pDestination | rol <pDestination+1 ;16
        asl <pDestination | rol <pDestination+1 ;32
        lda VVramOffset_.x_ | clc | adc <pDestination | tay
        lda <pDestination+1 | adc #0 | tax
	pla
rts


; void VVramBackToFront()
cseg
VVramBackToFront_: public VVramBackToFront_
    pha
        lda #low VVramBack_ | sta <pSource
        lda #high VVramBack_ | sta <pSource+1
        lda #low VVramFront_ | sta <pDestination
        lda #high VVramFront_ | sta <pDestination+1
        lda #VVramHeight | sta <count
        do
            ldy #0
            do
                lda (<pSource),y
                sta (<pDestination),y
                iny
                cpy #VVramWidth
            while ne | wend
            lda <pSource | clc | adc #low VVramWidth | sta <pSource
            lda <pSource+1 | adc #high VVramWidth | sta <pSource+1
            lda <pDestination | clc | adc #low VVramWidth | sta <pDestination
            lda <pDestination+1 | adc #high VVramWidth | sta <pDestination+1
            dec <count
        while ne | wend

        lda #0
        ldy #0
        do
            sta RowFlags_,y
            iny
            cpy #3
        while ne | wend
    pla
rts


; void SetRowFlags(byte y, byte b);
dseg
SetRowFlags_@Param0: public SetRowFlags_@Param0
    defb 0
SetRowFlags_@Param1: public SetRowFlags_@Param1
    defb 0
SetRowFlags_low equ ZB0
SetRowFlags_high equ ZB1
cseg
SetRowFlags_: public SetRowFlags_
    pha
        lda SetRowFlags_@Param1 | sta <SetRowFlags_low
        lda #0 | sta <SetRowFlags_high
       
        lda SetRowFlags_@Param0
        tay
        and #7
        tax
        do | while ne
            asl <SetRowFlags_low | rol <SetRowFlags_high
            dex
        wend
        
        tya
        lsr a | lsr a | lsr a
        tax
        
        lda RowFlags_,x
        ora <SetRowFlags_low
        sta RowFlags_,x
        inx
        lda RowFlags_,x
        ora <SetRowFlags_high
        sta RowFlags_,x
    pla
rts