#include "Vram.h"
#include "VVram.h"
#include "CopyMemory.h"
#include "Chars.h"

extern const byte[] Chars;

byte[256] CharColors;

static const byte[] ColorSource = {
    Char_Logo, 16, 0x63,
    Char_EnemyBullet, 1, 0x67,
    Char_EnemyA, 32, 0x66,
    Char_EnemyB, 32, 0x62,
    Char_EnemyC, 32, 0x77,
    Char_Bang, 20, 0x42,
    Char_Item, 4, 0x6F,
    0xff
};

static void SetColor(ptr<byte> pColor, byte color, byte count)
{
    do {
        *pColor = color;
        ++pColor;
        --count;
    } while (count != 0);
}


void InitVram()
{
    ptr<byte> pColor, pSource;

    pColor = CharColors;
    repeat (0) {
        *pColor = 0x71;
        ++pColor;
    }

    pSource = ColorSource;
    while (pSource[0] != 0xff) {
        byte count, color;
        pColor = CharColors + pSource[0];
        count = pSource[1];
        color = pSource[2];
        pSource += 3;
        do {
            *pColor = color;
            ++pColor;
            --count;
        } while (count > 0);
    }
    CopyMemory(PatternRam, Chars, Char_End * PatternSize);
}


void ClearScreen()
{
    FillMemory(Vram, VramRowSize * VramHeight, Char_Space);
    FillMemory(ColorMap, VramRowSize * VramHeight, 0x7f);
}


ptr<byte> PrintC(ptr<byte> pVram, byte c)
{
    return Put(pVram, c - ' ');
}


ptr<byte> Put2C(ptr<byte> pVram, byte c)
{
    repeat (2) {
        repeat (2) {
            pVram = Put(pVram, c);
            ++c;
        }
        pVram += VramRowSize - 2 * VramStep;
    }
    return pVram + 2 * VramStep - VramRowSize * 2;
}


ptr<byte> Erase2(ptr<byte> pVram)
{
    repeat (2) {
        repeat (2) {
            pVram = Put(pVram, Char_Space);
        }
        pVram += VramRowSize - 2 * VramStep;
    }
    return pVram + 2 * VramStep - VramRowSize * 2;
}
