include 'Zeropage.inc'
include 'Vram.inc'
include 'VVram.inc'

ext VVramFront_, RowFlags_
ext CharColors_

VramTop equ Vram
ColorTop equ ColorMap

pSource equ ZW0
pDestination equ ZW1
pColorMap equ ZW2
yCount equ ZB0
flagOffset equ ZB1
flagBit equ ZB2

; void Put(ptr<byte>, byte c);
dseg
Put_@Param0: public Put_@Param0
Put_pVram:
    defw 0
Put_@Param1: public Put_@Param1
Put_c:
    defb 0
cseg
Put_: public Put_
    pha
        lda Put_pVram | sta <pDestination
        lda Put_pVram+1 | sta <pDestination+1
        lda Put_c
        ldy #0
        sta (<pDestination),y
        tax
        lda <pDestination+1
        clc|adc #high(ColorMap-Vram)
        sta <pDestination+1
        lda CharColors_,x
        sta (<pDestination),y

        lda Put_pVram | clc|adc #1 | tay
        lda Put_pVram+1 | adc #0 | tax
    pla
rts


InitRow:
    lda #low VVramFront_ | sta <pSource
    lda #high VVramFront_ | sta <pSource+1
    lda #low Vram | sta <pDestination
    lda #high Vram | sta <pDestination+1
    lda #low ColorMap | sta <pColorMap
    lda #high ColorMap | sta <pColorMap+1
rts

NextRow:
    lda <pSource | clc | adc #low VVramWidth | sta <pSource
    lda <pSource+1 | adc #high VVramWidth | sta <pSource+1
    lda <pDestination | clc | adc #low VramWidth | sta <pDestination
    lda <pDestination+1 | adc #high VramWidth | sta <pDestination+1
    lda <pColorMap | clc | adc #low VramWidth | sta <pColorMap
    lda <pColorMap+1 | adc #high VramWidth | sta <pColorMap+1
rts

VVramToVramRow:
    ldy #0
    do
        lda (<pSource),y
        sta (<pDestination),y
        tax
        lda CharColors_,x
        sta (<pColorMap),y
        iny
        cpy #VVramWidth
    while ne | wend
rts

ClearRowFlags:
    ldx #0
    lda #0
    do
        sta RowFlags_,x
        inx
        cpx #4
    while ne | wend
rts

; void VVramToVramAll();
cseg
VVramToVramAll_: public VVramToVramAll_
    pha
        jsr InitRow
        lda #VVramHeight | sta <yCount
        do
            jsr VVramToVramRow
            jsr NextRow
            dec <yCount
        while ne | wend
        jsr ClearRowFlags
    pla
rts


; void VVramToVramChanged();
cseg
VVramToVramChanged_: public VVramToVramChanged_
    pha
        jsr InitRow

        ldx #0 | stx <flagOffset
        lda #1 | sta <flagBit

        lda #VVramHeight | sta <yCount
        do
            ldx <flagOffset
            lda RowFlags_,x
            and <flagBit
            if ne
                jsr VVramToVramRow
            endif
            jsr NextRow
            asl <flagBit
            if eq
                ldx <flagOffset | inx | stx <flagOffset
                lda #1 | sta <flagBit
            endif
            dec <yCount
        while ne | wend
        jsr ClearRowFlags
    pla
rts